#include "stc.h"
#include "uart.h"


BOOL bUartRxReady;

BYTE UartrecvIndex;
BYTE UartRecvStep;
BYTE UartRecvSum;

BYTE xdata UartTxBuffer[256];
BYTE xdata UartRxBuffer[256];

void uart_init()
{
	S3CON = 0x10;		//8λ,ɱ䲨
	S3CON &= 0xBF;		//3ѡʱ2Ϊʷ
	AUXR |= 0x04;		//ʱʱ1Tģʽ
	T2L = BAUD;			//öʱʼֵ
	T2H = BAUD >> 8;	//öʱʼֵ
	AUXR |= 0x10;		//ʱ2ʼʱ
    
    uart_recv_done();
}


void uart_isr()
{
    BYTE dat;
    
    if (S3CON & 0x01)
    {
         S3CON &= ~0x01;
        
        UartRecvSum += (dat = S3BUF);
        switch (UartRecvStep)
        {
        case 0:
L_CheckHead:
            UartRecvStep = ((UartRecvSum = dat) == '#');
            break;
        case 1:
            UartRxBuffer[0] = dat;
            UartrecvIndex = 0;
            UartRecvStep++;
            break;
        case 2:
            UartRxBuffer[1 + UartrecvIndex++] = dat;
            if (UartrecvIndex >= UartRxBuffer[0])
                UartRecvStep++;
            break;
        case 3:
            if (dat != '$') goto L_CheckHead;
            UartRecvStep++;
            break;
        case 4:
            if (UartRecvSum != 0) goto L_CheckHead;
            bUartRxReady = 1;
            UartRecvStep++;
            break;
        default:
            break;
        }
    }
}


static BYTE send(BYTE dat)
{
    S3BUF = dat;
    while ((S3CON & 0x02) == 0);
    S3CON &= ~0x02;
    
    return dat;
}

void uart_send(BYTE status, BYTE size)
{
    BYTE sum;
    BYTE i;
    
    sum = send('@');
    sum += send(status);
    sum += send(size);
    if (size)
    {
        for (i = 0; i < size; i++)
        {
            sum += send(UartTxBuffer[i]);
        }
    }
    sum += send('$');
    send(-sum);
}

void uart_recv_done()
{
    bUartRxReady = 0;
    UartrecvIndex = 0;
    UartRecvStep = 0;
    UartRecvSum = 0;
}


